//+------------------------------------------------------------------+
//| 3 ducks indicator      version 1                                 |
//|                                                                  |
//|      The indicator follows the rules of original 3 ducks system. |
//|      Indicator status is shown in the right upper corner of the  |
//|      chart. When all 3 timeframes have the same color, sell or   |
//|      buy.                                                        |
//|      Indicator also contains an audible alarm.                   |
//|      Indicator position in the window can be adjusted.           |
//|                                                                  |
//|                   by Rocroy, 3-22-2008                           |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window

extern color ColorUpGood = Lime;
extern color ColorDownGood = Red;
extern int   Left_position = 0;
extern bool  SoundON=false;
extern int   Number_of_Alarms = 5;

static int   alertTag, alertcount;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorShortName("3 Ducks");
   alertcount = Number_of_Alarms;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0,OBJ_LABEL); 
   ObjectDelete("heading"); ObjectDelete("M30"); ObjectDelete("H1"); ObjectDelete("H4"); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {    
    
    //h1 data
    double h1advanced_adx = iMA(NULL,PERIOD_H1,2,0,MODE_SMA,PRICE_CLOSE,0);

    //h4 data
    double h4advanced_adx = iMA(NULL,PERIOD_H4,2,0,MODE_SMA,PRICE_CLOSE,0);

    //d1 data
    double d1advanced_adx = iMA(NULL,PERIOD_D1,2,0,MODE_SMA,PRICE_CLOSE,0);
    
    //define color
    color color_h1, color_h4, color_d1;
    
    //define string
    string arrow_h1, arrow_h4, arrow_d1;
        

    //h1 up trend
    if (h1advanced_adx < Bid ) { color_h1 = ColorUpGood; }
    
    //h1 down trend
    if (h1advanced_adx > Bid ) { color_h1 = ColorDownGood; }

    //h4 up trend
    if (h4advanced_adx < Bid ) { color_h4 = ColorUpGood; }
    
    //h4 down trend
    if (h4advanced_adx > Bid ) { color_h4 = ColorDownGood; }

    //d1 up trend
    if (d1advanced_adx < Bid ) { color_d1 = ColorUpGood; }
    
    //d1 down trend
    if (d1advanced_adx > Bid ) { color_d1 = ColorDownGood; }
    
    
    //Heading           
    ObjectCreate("heading", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("heading","Trend",25, "Segoe UI", color_h1);
        ObjectSet("heading", OBJPROP_XDISTANCE, 925+Left_position);
        ObjectSet("heading", OBJPROP_YDISTANCE, 15);
        
    //Signal Labels           
    ObjectCreate("H1", OBJ_LABEL, 0, 0, 0);//M5 SIGNAL
        ObjectSetText("H1","H1",20, "Segoe UI", color_h1);
        ObjectSet("H1", OBJPROP_XDISTANCE, 890+Left_position);
        ObjectSet("H1", OBJPROP_YDISTANCE, 65);
        
    ObjectCreate("H4", OBJ_LABEL, 0, 0, 0);//H1 SIGNAL
        ObjectSetText("H4","H4",20, "Segoe UI", color_h4);
        ObjectSet("H4", OBJPROP_CORNER, 0);
        ObjectSet("H4", OBJPROP_XDISTANCE, 950+Left_position);
        ObjectSet("H4", OBJPROP_YDISTANCE, 65);
        
    ObjectCreate("D1", OBJ_LABEL, 0, 0, 0);//H4 SIGNAL
        ObjectSetText("D1","D1",20, "Segoe UI", color_d1);
        ObjectSet("D1", OBJPROP_CORNER, 0);
        ObjectSet("D1", OBJPROP_XDISTANCE, 1010+Left_position);
        ObjectSet("D1", OBJPROP_YDISTANCE, 65);

   
      if (h1advanced_adx < Bid) { arrow_h1 = "5"; }
      if (h1advanced_adx > Bid) { arrow_h1 = "6"; }

      if (h4advanced_adx < Bid) { arrow_h4 = "5"; }
      if (h4advanced_adx > Bid) { arrow_h4 = "6"; }

      if (d1advanced_adx < Bid) { arrow_d1 = "5"; }
      if (d1advanced_adx > Bid) { arrow_d1 = "6"; }

      
      //arrow h1
      //ObjectCreate("ObjLabel9a", OBJ_LABEL, 0, 0, 0);
        //ObjectSetText("ObjLabel9a",arrow_h1,10, "Webdings", color_h1);
        //ObjectSet("ObjLabel9a", OBJPROP_XDISTANCE, 200+Left_position);
        //ObjectSet("ObjLabel9a", OBJPROP_YDISTANCE, 23);
        
      //arrow h4
      //ObjectCreate("ObjLabel10a", OBJ_LABEL, 0, 0, 0);
        //ObjectSetText("ObjLabel10a",arrow_h4,10, "Webdings", color_h4);
        //ObjectSet("ObjLabel10a", OBJPROP_XDISTANCE, 225+Left_position);
        //ObjectSet("ObjLabel10a", OBJPROP_YDISTANCE, 23);
    
      //arrow d1
      //ObjectCreate("ObjLabel11a", OBJ_LABEL, 0, 0, 0);
        //ObjectSetText("ObjLabel11a",arrow_d1,10, "Webdings", color_d1);
        //ObjectSet("ObjLabel11a", OBJPROP_XDISTANCE, 250+Left_position);
        //ObjectSet("ObjLabel11a", OBJPROP_YDISTANCE, 23);        
        
// alarms
      
      if ( color_h1 != color_h4 || color_h4 != color_d1 ) alertcount = Number_of_Alarms;
      
      if (SoundON==true && color_h1 == color_h4 && color_h4 == color_d1 &&
         alertcount>0 && alertTag!=TimeMinute(TimeCurrent()) )
      {
         Alert(" 3 Ducks in a row! ",Symbol());
         alertTag = TimeMinute(TimeCurrent());
         if (alertcount > 0) alertcount--;
      }
      
        
//----
    return(0); 
//----
} 

//+------------------------------------------------------------------+